#include <iostream.h>  
#include "cone.hpp" 

bool cone::isEmpty( ) {
  if ( beta1 > beta2 ) return 1 ; 
  return 0 ; 
}

bool cone::isContains(mypoint *p) { 
  double xco, yco;
  double angle, slope ; 

  xco = p->x() ; 
  yco = p->y() ; 

  slope = ( yco - center->y() ) /  ( xco - center->x() ) ; 
  angle = atan ( slope ) ;  
 
  angle = angle + M_PI_2 ;  
  
  if ( angle >= beta1 && angle <= beta2 ) return 1 ; 
  else return 0; 
}

void cone::doUpdate(mypoint *p, double eps) { 
  double xco, yco;
  double angle, slope ; 

// updating beta1 
  xco = p->x() ; 
  yco = p->y() - eps ; 

  slope = ( yco - center->y() ) /  ( xco - center->x() ) ; 
  angle = atan ( slope ) ;  
 
  angle = angle + M_PI_2 ;  
  
// set to max of beta1 and angle 
  if ( beta1 < angle ) beta1 = angle; 


// updating beta2 
  xco = p->x() ; 
  yco = p->y() + eps ; 

  slope = ( yco - center->y() ) /  ( xco - center->x() ) ; 
  angle = atan ( slope ) ;  
 
  angle = angle + M_PI_2 ;  
  
// set to min of beta2 and angle 
  if ( beta2 > angle ) beta2 = angle; 
}


