//============================================================================
// Graph.cpp
//============================================================================

#include "graph.h"

Graph::Graph(int n)
{
  indextonode = new leda_node[n]; 
  count = 0 ; 
}

Graph::~Graph()
{
  seggraph.clear() ;
  delete *indextonode ;
}

void Graph::addNode( unsigned int nodeindex ) 
{
  leda_node n = seggraph.new_node() ; 
  indextonode[count++] =  n ;
} 

void Graph::addEdge( unsigned int vertex1, unsigned vertex2 ) 
{
  leda_edge myedge = seggraph.new_edge( indextonode[vertex1], indextonode[vertex2] ) ;
}

leda_node Graph::getnode( unsigned int pos )
{
  if ( pos > count ) 
  {
    cout << "Getting out-of-bounds node.\n" ; 
    return NULL ; 
  }
  
  return indextonode[pos] ;
}

void Graph::clear()
{
  seggraph.del_all_edges() ;
}

int Graph::size() 
{
  return seggraph.number_of_edges() ; 
}
