#include <iostream.h>  
#include "pointset.hpp" 
#include "segment.hpp" 
#include "vector" 

void pointset::sortPoints() {
	for (int j=1; j < size() ; j++) {
	    double key = get(j)->x() ;
	    double xtra = get(j)->y() ;
	    int i = j - 1 ;
	    while ( i >= 0 && get(i)->x() > key ) {
		input [ i+ 1]  =  get(i); 
		i-- ;
	    }
	    input[ i+1 ] =  new mypoint(key, xtra); 
	}
}


int pointset::verifySubset( pointset *invec, double eps ) {
	segment *seg = new segment() ;
	int current = 0, start = 0;
	for (int i= 1; i < size() ; i++) {
	    for (; invec->get(current)->x() < get(i)->x() ; current++) ;
	    for (int counter = start + 1 ; counter < current; counter++)
		if ( !seg->intersect ( invec, start, current, counter, eps ) )
		    return 0 ;
	    start = current ;
	}	
	return 1 ;
}
