#ifndef _SEGMENT_ 
#define _SEGMENT_ 

#include <iostream.h> 
#include "pointset.hpp" 

class segment {
  public: 

    mypoint  *p; 
    mypoint  *q; 
    
    segment(void) { }

    segment(mypoint *a, mypoint *b) {
	p = new mypoint(a) ;
	q = new mypoint(b) ;
    }

    segment(double x1, double y1, double x2, double y2) {
	p->setx(x1) ;
	p->sety(y1) ;
	
	q->setx(x2) ;
	q->sety(y2) ;
    }

    int aboveSegment(mypoint *in, mypoint *p1, mypoint *q1);  

    int aboveSegment(mypoint *in) ; 

    int intersectSegments(mypoint *p1, mypoint *p2, mypoint *p3, mypoint *p4, mypoint *out) ; 

    int intersectSegment(mypoint *p1, mypoint *p2, mypoint *p3, double eps) ; 

    int intersect(pointset *invec, int i, int j, int k, double eps) ; 
};  

#endif 
