#ifndef _CONE_ 
#define _CONE_ 

#include<stdio.h> 
#include<math.h> 
#include <iostream.h> 
#include "mypoint.hpp"

class cone {
  private: 

    double  beta1; 
    double  beta2;
    mypoint *center; 

  public:

    cone(void) {
        beta1 = beta2 = 0 ;
        center = new mypoint( )  ; 
    }

    cone( mypoint *p, double b1 = 0, double b2 = M_PI) {
      beta1 = b1 ; 
      beta2 = b2 ; 
      center = new mypoint( p->x(), p->y() ) ; 
    }
  
    void initialize( mypoint *p, double b1 = 0, double b2 = M_PI) {
      beta1 = b1 ; 
      beta2 = b2 ; 
      center = new mypoint( p->x(), p->y() ) ; 
    }

    void print( ) {
      center->print() ; 
      cout << "Beta1: " << beta1 << " Beta2: " << beta2 << endl; 
    }

    bool isEmpty( ) ; 
    bool isContains(mypoint *p) ; 
    void doUpdate(mypoint *p, double eps) ; 
};   

#endif
