//============================================================================
// Graph.hpp
//============================================================================

#ifndef _GRAPH_
#define _GRAPH_

#include "vector.h"
#include "iostream.h"
#include "LEDA/graph.h"
#include "LEDA/point.h"

class Graph
{
  private: 
    leda_node *indextonode ; 
    int count; 

  public:
    leda_graph seggraph ; 

    Graph(int) ;
    ~Graph() ;
 
    void addNode( unsigned int nodeindex ) ; 
    void addEdge( unsigned int vertex1, unsigned vertex2 ); 
    leda_node getnode( unsigned int pos ) ;
    void clear() ;
    int size() ;
};

#endif
